#!/bin/sh

if [ $# = 0 ]; then
	echo "usage: $0 <dir> [<dir> ...]"
	echo "  Converts old-style .onenter and .onleave scripts to new ~/.ondirrc"
	echo "  style enter/leave events"
	exit 1
fi

for D in $@; do 
	cd $D
	D=$PWD
	cd -
	if [ -r $D/.onenter -o -r $D/.onleave ]; then
		echo "path \"$D\" {" >> ~/.ondirrc
		if [ -r $D/.onenter ]; then
			echo "ondir/migrate: migrated $D/.onenter"
			echo "	enter {" >> ~/.ondirrc
			cat $D/.onenter >> ~/.ondirrc
			echo "	}" >> ~/.ondirrc
		fi
		if [ -r $D/.onleave ]; then
			echo "ondir/migrate: migrated $D/.onleave"
			echo "	leave {" >> ~/.ondirrc
			cat $D/.onleave >> ~/.ondirrc
			echo "	}" >> ~/.ondirrc
		fi
		echo "}" >> ~/.ondirrc
	fi
done
