#include <cctype>
#include "RCLexer.h"

//    ignorePattern(WHITESPACE, "[[:space:]]+");
//	    ignorePattern(COMMENT, "#.*");
//		    addPattern(STRING, "\"(\\.|.)*\"");
//			    addPattern(KW_PATH, "\\<path\\>");
//				    addPattern(KW_ENTER, "\\<enter\\>");
//					    addPattern(KW_LEAVE, "\\<(exit|leave)\\>");
Lexer::MatchResult RCLexer::get(string &out, char const *&end, char const *&start, int &type) {
bool ignored = true;

	while (ignored) {
		ignored = false;
		start = end;
		// whitespace
		if (*end && isspace(*end)) {
			++end;
			while (*end && isspace(*end)) ++end;
			if (macceptws) {
				type = WHITESPACE;
				return MATCH_SOURCE;
			}
			ignored = true;
		}
		start = end;
		// comments
		if (*end == '#') {
			++end;
			while (*end && *end != '\n' && *end != '\r') ++end;
			ignored = true;
		}
	}
	start = end;

	// string
	if (*end == '"') {
	char const *mark = end;

		++end;
		while (*end && ((*end == '\\' && end[1]) || *end != '"')) {
			if (*end == '\\') ++end;
			++end;
		}
		if (*end == '"') {
			++end;
			type = STRING;
			return MATCH_SOURCE;
		}
		end = mark;
	}

	// path
	if (!strncmp(end, "path", 4)) {
		end += 5;
		type = KW_PATH;
		return MATCH_SOURCE;
	}

	// enter
	if (!strncmp(end, "enter", 5)) {
		end += 6;
		type = KW_ENTER;
		return MATCH_SOURCE;
	}

	// leave
	if (!strncmp(end, "leave", 5)) {
		end += 6;
		type = KW_LEAVE;
		return MATCH_SOURCE;
	}

	return MATCH_NONE;
}
